//1,"fix_tin_2022.sc","fix_tin_2022.sc",1.01,SYSTEM
//Copyright (c) Sage sp. z o.o.. Wszelkie prawa zastrzeżone.
//FIX do TIN w wersji 2022 - do usuniecia w kolejnych wersjach
string sql

sql += "IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[FK].[fk_Jpk_GetV7Exceptions2]') AND type in (N'P', N'PC'))\n"
sql += "DROP PROCEDURE [FK].[fk_Jpk_GetV7Exceptions2]\n"

dispatch cn = GetAdoConnection()
cn.execute(sql, 0, 0x80 + 0x01)
sql = ""

sql += "CREATE PROCEDURE [FK].[fk_Jpk_GetV7Exceptions2]\n"
sql += "@data_od [fk].[tData],\n"
sql += "@data_do [fk].[tData],\n"
sql += "@zrodlo smallint,\n"
sql += "@typDekl int\n"
sql += "AS\n"
sql += "--procedura tymczasowa związana z FIX TIN w wersji 22.00\n"

sql += "SELECT te.[id], te.[nrpola], te.[kwota],\n"
sql += "	CASE WHEN te.[dokId] > 0 THEN d.[nazwa] ELSE (case when IsNull(te.[NumerDok], '')<>'' then te.[NumerDok] else te.[opis] end) END opis, \n"
sql += "	CASE WHEN te.[dokId] > 0 THEN d.[datadok] ELSE te.[dataWpr] END dataWpr,\n"
sql += "	CASE WHEN te.[dokId] > 0 and d.[dataOper] is not null THEN d.[dataOper] ELSE te.[dataOper] END dataOper,	\n"
sql += "	te.KthNIP as nip,\n"
sql += "	kth.VIES as vies,	\n"
sql += "	te.kthNazwa as nazwa,\n"
sql += "	CASE WHEN te.[dokId] > 0 THEN dkh.kraj ELSE (select kodkraju from FK.fk_kontrahenci where id = te.kthId) end as kraj,\n"
sql += "	IsNull(te.[atrJpkV7Dok], '') atrJpkV7Dok\n"
sql += "FROM fk.DEKL dk\n"
sql += "JOIN fk.TABEXC te ON te.[iddekl] = dk.[idx]\n"
sql += "LEFT JOIN fk.dokumenty d ON d.[rokId] = te.[rokId] AND d.[id] = te.[dokId]\n"
sql += "LEFT JOIN fK.fk_DANEKH dkh ON dkh.id = d.danekh\n"
sql += "LEFT JOIN SSCommon.STContractors kth ON kth.id = te.kthId\n"
sql += "WHERE dk.[typDekl] = @typDekl\n"
sql += "	AND te.[okres] BETWEEN @data_od AND @data_do\n"
sql += "	AND (te.[zrodlo] <= @zrodlo OR te.[zrodlo] IN (2, 3))\n"



cn.execute(sql, 0, 0x80 + 0x01)
sql = ""

sql += "IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[FK].[fk_Jpk_GetVatDokumenty2]') AND type in (N'P', N'PC'))\n"
sql += "DROP PROCEDURE [FK].[fk_Jpk_GetVatDokumenty2]\n"



cn.execute(sql, 0, 0x80 + 0x01)
sql = ""

sql += "CREATE PROCEDURE [FK].[fk_Jpk_GetVatDokumenty2]\n"
sql += "	@dataOd FK.tData,\n"
sql += "	@dataDo FK.tData,\n"
sql += "	@zrodlo SMALLINT,\n"
sql += "	@zZerowymi SMALLINT\n"
sql += "AS\n"
sql += "--procedura tymczasowa związana z FIX TIN w wersji 22.00\n"
sql += "    WITH vat (rokId, Id, pozNum, numer, numerWl, datadok, dataws, danekh, rZs, rejAtrJpkV7)\n"
sql += "	AS\n"
sql += "	(\n"
sql += "        SELECT d.rokId, d.Id, rv.pozNum, d.nazwa, rv.numerWl, min(rv.datadok), min(rv.dataWS), rv.danekh, dr.rZs\n"
sql += "				--STRING_AGG( rv.atrJpkV7, ',' ) rejAtrJpkV7 -- STRING_AGG() jest od SQL 2017, wersja dla SQL2014:\n"
sql += "				,STUFF((SELECT DISTINCT ',' + RTRIM(LTRIM(art.atrJpkV7)) FROM FK.rejVat art WHERE art.atrJpkV7 is not null and art.rokDok = d.rokId AND art.dId = d.Id FOR XML PATH ('')),1,1,'')  rejAtrJpkV7\n"
sql += "		FROM FK.dokumenty d\n"
sql += "		JOIN FK.rejVat rv ON rv.rokDok = d.rokId AND rv.dId = d.Id\n"
sql += "       JOIN FK.defRej dr ON rv.def = dr.id\n"
sql += "		WHERE rv.okres BETWEEN @dataOd AND @dataDo AND rv.nienaliczany = 0 AND d.zrodlo <= @zrodlo\n"
sql += "			AND (@zZerowymi <> 0 OR rv.netto <> 0)\n"
sql += "        GROUP BY d.rokId, d.Id, rv.pozNum, d.nazwa, rv.numerWl, rv.danekh, dr.rZs\n"
sql += "	)\n"

sql += "	-- generalnie daty czytane z rekordu dokumentu\n"
sql += "	-- tylko dla dokumentów RK i RL data dokumentu określana na podstawie datadok w rejestrze bo data z nagłówka dotyczy dokumentu RK i RL, a nie rozliczanej faktury\n"
sql += "	-- tylko dla dokumentów RK i RL data wpływu i sprzedaży określana na podstawie dataws w rejestrach VAT bo nie ma ich w dokumencie\n"
sql += "	-- [datawpl] - data wpływu określona jest dla zakupu (rZs=1) lub importu (rZs=3)\n"
sql += "	-- [dataws] - data wpływu/sprzedaży rejestru VAT - określona jest dla sprzedaży (rZs=2) lub eksportu (rZs=4)\n"

sql += "	-- defRej.rZs - stałe określające typ dokumentu w kontekście rejestrów VAT\n"
sql += "	-- const int DT_ZAKUP         = 1;	// dokum. zakupu\n"
sql += "	-- const int DT_SPRZEDAZ      = 2;	// dokum. sprzedaży\n"
sql += "	-- const int DT_IMPORT		  = 3;	// import\n"
sql += "	-- const int DT_EXPORT		  = 4;	// export\n"

sql += "	-- dok.wzorzec\n"
sql += "	-- const int DW_RAPORT_K      = 6;\n"
sql += "	-- const int DW_ROZL_ZALICZKI = 15;\n"

sql += "    SELECT vat.rokId, vat.Id, vat.pozNum, vat.numer, vat.numerWl, \n"
sql += "			CASE WHEN dok.wzorzec IN (6, 15) THEN vat.datadok ELSE dok.datadok END AS datadok, \n"
sql += "	        CASE WHEN vat.rZs=2 AND dok.wzorzec IN (6, 15) THEN vat.dataws ELSE dok.dataOper END AS dataws,\n"
sql += "			CASE WHEN vat.rZs=1 AND dok.wzorzec IN (6, 15) THEN vat.dataws ELSE dok.datawpl END AS datawpl,\n"
sql += "			dok.dataOper,\n"
sql += "			dkh.nip,\n"
sql += "			kth.VIES as vies, \n"
sql += "			kth.pesel, dkh.nazwa, dkh.ulica, dkh.dom, dkh.lokal, dkh.kodPocztowy, dkh.miejscowosc, dkh.kraj, vat.rZs, dok.atrJpkV7 as docAtrJpkV7,\n"
sql += "			CASE WHEN LEFT(vat.rejAtrJpkV7, 1) = ',' THEN RIGHT(vat.rejAtrJpkV7, LEN(vat.rejAtrJpkV7) - 1) ELSE vat.rejAtrJpkV7 END\n"
sql += "	FROM vat\n"
sql += "	JOIN FK.dokumenty dok ON vat.rokId = dok.rokId AND vat.Id = dok.Id\n"
sql += "	LEFT JOIN FK.fk_DANEKH dkh ON dkh.id = vat.danekh\n"
sql += "	LEFT JOIN SSCommon.STContractors kth on  kth.MainElement = \n"
sql += "						(select Guid from SSCommon.STElements \n"
sql += "						where Position = dkh.kontrahent AND\n"
sql += "						 ElementKindId = (select ElementKindId from SSCommon.STElementKinds where Guid ='BC090993-0768-4487-BE6F-E44E9501734C'))\n"
	


cn.execute(sql, 0, 0x80 + 0x01)